/* 
 * $Id: KFCWnd.cpp 3 2009-12-20 19:12:53Z krkim $ $Revision: 3 $
 * $HeadURL: https://krkim-laptop/svn/KFC/trunk/KFCWnd.cpp $
 * official release : http://www.durumul.com/kfclib
 */

#include "stdafx.h"
#include "KFCWndMap.h"
#include "KFCWnd.h"
#include "KFCApp.h"
#include "kxNSMenu.h"
#include "kxFrame.h"
#include "kxHookMenu.h"
//IME
#include <Imm.h>
#include <ime.h>
#pragma comment(lib,"imm32.lib")

/*This all sources are created by krkim,KFC library*/

/*$Id: KFCWnd.cpp 3 2009-12-20 19:12:53Z krkim $*/

//ս ̶ ø ̺  ʴ´.
//it did not use the MAPPING TABLE for more high-performance.
//but,if you want to use,uncomment below!

//#define USE_MAPTABLE

#pragma warning(disable:4244)

_KFC_BEGIN_PACK(WND)
extern KFCModule kxModule;
_KFC_END_PACK

LPFN_OnMeasureItem gfp_MeasureItem=NULL;
LPFN_OnDrawItem gfp_DrawItem = NULL;
LPFN_OnInitMenuPopup gfp_InitMenuPopup = NULL;

//Window Base Procedure
// Ϸ CBT hook ؾѴ.ڲ ̴  MFCó Ƿ   .
//For more exact action,use SetWindowsHookEx(WH_CBT ...),but i have no more expect to do it..
//i want to keep slice that is the purpose of this library also.
//WM_CREATE WM_INITDIALOG   class mapping is not yet.
//so WM_GETMINMAXINFO,WM_NCCREATE,WM_NCCALCSIZE is not handled in class member function.
LRESULT CALLBACK KFCWnd::WindowProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	LRESULT lResult = 0;
	KFCWnd *pWnd = KFCWnd::GetPointer(hWnd);
	
	//if(_KFCModule.m_debugmode & 0x01){
	//	CHAR msg[128];
	//	wsprintf(msg,"msg = [0x%08X] hWnd = %X\n",message,hWnd);
	//	OutputDebugString(msg);
	//}
	pWnd->m_nWndMsg ++;
	if(!pWnd->OnWndMsg(message, wParam, lParam, lResult)){//pass to default window proc
		if(message != WM_NCDESTROY)
			lResult = pWnd->DefWindowProc(hWnd, message, wParam, lParam);
		else{
			LONG_PTR pfnWndProc = ::GetWindowLongPtr(pWnd->m_hWnd, GWLP_WNDPROC);
			lResult = pWnd->DefWindowProc(hWnd, message, wParam, lParam);
			if(pWnd->m_fnSuper != ::DefWindowProc && ::GetWindowLongPtr(pWnd->m_hWnd, GWLP_WNDPROC) == pfnWndProc)
				::SetWindowLongPtr(pWnd->m_hWnd, GWLP_WNDPROC, (LONG_PTR)pWnd->m_fnSuper);
			pWnd->m_dwState |= WINSTATE_DESTROYED;
		}
	}
	else{//if message was handled

	}
	pWnd->m_nWndMsg --;
	if((pWnd->m_dwState & WINSTATE_DESTROYED))
	{
		pWnd->m_hWnd = NULL;
		KFCWnd::SetPointer(hWnd,NULL);
		if(pWnd->m_nWndMsg == 0){
			pWnd->m_dwState &= ~WINSTATE_DESTROYED;
			//clean up after window is destroyed
			pWnd->OnFinalMessage();
		}
	}
	return lResult;
}

//already registered system class window,never reach in,
//so after create and call subclasswindow() externally.
LRESULT CALLBACK KFCWnd::KFCWndBaseProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	WNDPROC pOldProc;
	KFCWnd * pThis = (KFCWnd *)kxModule.PopCreateWndData();
	ASSERT(pThis != NULL);
	if(!pThis)
		return 0L;
	pThis->m_hWnd = hWnd;
	KFCWnd::SetPointer(hWnd,pThis);
	WNDPROC pProc = pThis->GetWindowProc();
	pOldProc = (WNDPROC)::SetWindowLongPtr(hWnd, GWLP_WNDPROC, (LONG_PTR)pProc);
	return pProc(hWnd,message,wParam,lParam);
}

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
KFCWnd::KFCWnd(HWND hWnd)
{
	m_nWndMsg = 0;
	m_dwState = 0;
	m_hWnd = hWnd;
	m_hParentWnd = ::GetParent(m_hWnd);
	m_ID = 0;
	m_parent = NULL;
	m_fnSuper = ::DefWindowProc;
	m_bCreatedByMe = 0;
	m_nActive = 0;
	m_bSubClassed = 0;
	m_nRefMap = 0;
	m_FadeIO.hThreadFadeIn = NULL;
	m_FadeIO.bCreated = FALSE;
	m_FadeIO.nStep = 10;
	m_FadeIO.nDelay = 5;
	m_nIconIndex = -1;
}

KFCWnd::~KFCWnd()
{
	if(m_bCreatedByMe)
		DestroyWindow();
}

void KFCWnd::SetHandle(HWND hWnd)
{
	m_hWnd = hWnd;
	m_hParentWnd = ::GetParent(m_hWnd);
}

kxString KFCWnd::GetTitle()//2010.12.15
{
	kxString title = m_wndTitle;
	if(title.GetLength() < 1){
		title.SetLength(300);
		GetWindowText(title,300);
		m_wndTitle = title;
	}
	return title;
}

void KFCWnd::SetTitle(LPTSTR szTitle)
{
	m_wndTitle = szTitle;
	SetWindowText(szTitle);
}

BOOL KFCWnd::CreateEx(DWORD dwExStyle, LPCTSTR lpszClassName,
	LPCTSTR lpszWindowName, DWORD dwStyle,
	int x, int y, int nWidth, int nHeight,
	HWND hWndParent, HMENU nIDorHMenu, LPVOID lpParam)
{
	// allow modification of several common create parameters
	CREATESTRUCT cs;
	cs.dwExStyle = dwExStyle;
	cs.lpszClass = lpszClassName;
	cs.lpszName = lpszWindowName;
	cs.style = dwStyle;
	cs.x = x;
	cs.y = y;
	cs.cx = nWidth;
	cs.cy = nHeight;
	cs.hwndParent = hWndParent;
	cs.hMenu = nIDorHMenu;
	cs.hInstance = KFCGetInstanceHandle();
	cs.lpCreateParams = lpParam;
	m_ID = (UINT) nIDorHMenu;
	PreCreateWindow(cs);
	m_wndTitle = lpszWindowName;
	kxModule.PushCreateWndData(&m_cd,this);

	m_hWnd = ::CreateWindowEx(cs.dwExStyle, cs.lpszClass,cs.lpszName,cs.style,cs.x,cs.y,cs.cx,cs.cy,cs.hwndParent,cs.hMenu,cs.hInstance,cs.lpCreateParams);
	DWORD dwErr = 0;
#ifdef _DEBUG
	if(m_hWnd == NULL){
		dwErr = GetLastError();
		if(dwErr == ERROR_INVALID_MENU_HANDLE){
			throw KFCException("Error: please cs.hMenu = NULL on your derived PreCreateWindow()");		
		}
	//	throw KFCException("Warning: Window creation failed:");
	}
#endif
	if(m_hWnd == NULL) return FALSE;
	//effect when pass to cs.hMenu = NULL on call CreateWindowEx
	//::SetWindowLongPtr(m_hWnd,GWLP_ID,(LONG_PTR)nIDorHMenu);
	return TRUE;
}

//ϵ  (WS_CHILD)
BOOL KFCWnd::Create(LPCTSTR lpszClassName,LPCTSTR lpszWindowName, DWORD dwStyle,const RECT& rect,KFCWnd* pParentWnd,UINT nID)
{
  // can't use for desktop or pop-up windows (use CreateEx instead)
  /*ASSERT(pParentWnd != NULL);*/
  /*ASSERT((dwStyle & WS_POPUP) == 0);*/
  return CreateEx(0, lpszClassName, lpszWindowName,dwStyle | WS_CHILD,
    rect.left, rect.top,rect.right - rect.left, rect.bottom - rect.top,
    (pParentWnd == NULL? NULL:pParentWnd->GetSafeHwnd()), (HMENU)nID, (LPVOID)NULL);
}

BOOL KFCWnd::CreateEx(DWORD dwExStyle,LPCTSTR lpszClassName,LPCTSTR lpszWindowName,DWORD dwStyle,const RECT& rect,KFCWnd* pParentWnd,UINT nID,LPVOID lpParam /*=NULL*/)
{
	return CreateEx(dwExStyle, lpszClassName, lpszWindowName, dwStyle,
    rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top,
    (pParentWnd == NULL? NULL:pParentWnd->GetSafeHwnd()), (HMENU)nID, lpParam);
}

BOOL KFCWnd::CreateEx(DWORD dwExStyle,LPCTSTR lpszClassName,LPCTSTR lpszWindowName,DWORD dwStyle,const RECT& rect,HWND hParent,UINT nID,LPVOID lpParam /*=NULL*/)
{
	return CreateEx(dwExStyle, lpszClassName, lpszWindowName, dwStyle,
    rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top,
    hParent, (HMENU)nID, lpParam);
}

HWND KFCWnd::SetParent(HWND hParent)
{
	HWND hOld = ::SetParent(m_hWnd,hParent);
	m_hParentWnd = ::GetParent(m_hWnd);
	KFCWnd *pParent = KFCWnd::GetPointer(m_hParentWnd);
	m_parent = pParent;
	return hOld;
}

KFCWnd *KFCWnd::GetParentWnd()
{ 
	if(!m_parent || !m_parent->IsWindow()){
		m_hParentWnd = ::GetParent(m_hWnd);
		KFCWnd *pParent = KFCWnd::FromHandle(m_hParentWnd);
		m_parent = pParent;
	}
	return m_parent;
}

KFCWnd* KFCWnd::SetParent(KFCWnd* pWnd)
{
	HWND hOld = ::SetParent(m_hWnd,pWnd->GetSafeHwnd());
	m_hParentWnd = ::GetParent(m_hWnd);
	m_parent = pWnd;
	return KFCWnd::GetPointer(hOld);
}

kxFrame* KFCWnd::GetParentFrame()
{
	if (GetSafeHwnd() == NULL) // no Window attached
		return NULL;
	KFCWnd* pParentWnd = GetParentWnd();  // start with one parent up
	while (pParentWnd != NULL)
	{
		if (pParentWnd->IsFrameWnd())
			return (kxFrame*)pParentWnd;
		pParentWnd = pParentWnd->GetParentWnd();
	}
	return NULL;
}

kxFrame* KFCWnd::GetDockingFrame()
{
	kxFrame* pFrameWnd = GetParentFrame();
	//if (pFrameWnd == NULL)
	//	pFrameWnd = m_pDockSite;

	ASSERT(pFrameWnd != NULL);
	return pFrameWnd;
}

void KFCWnd::ScreenToClient(HWND hWnd,LPRECT lpRect) const
{
	::ScreenToClient(hWnd, (LPPOINT)lpRect);
	::ScreenToClient(hWnd, ((LPPOINT)lpRect)+1);
	if (GetWindowLongPtr(hWnd, GWL_EXSTYLE) & WS_EX_LAYOUTRTL){
		LONG temp = lpRect->left;
		lpRect->left = lpRect->right;
		lpRect->right = temp;	
	}
}


void KFCWnd::ClientToScreen(HWND hWnd,LPRECT lpRect) const
{
	::ClientToScreen(hWnd, (LPPOINT)lpRect);
	::ClientToScreen(hWnd, ((LPPOINT)lpRect)+1);
	if (GetWindowLongPtr(hWnd, GWL_EXSTYLE) & WS_EX_LAYOUTRTL){
		LONG temp = lpRect->left;
		lpRect->left = lpRect->right;
		lpRect->right = temp;	
	}
}

void KFCWnd::ScreenToClient(LPRECT lpRect) const
{
	ScreenToClient(m_hWnd,lpRect);
}

void KFCWnd::ClientToScreen(LPRECT lpRect) const
{
	ClientToScreen(m_hWnd,lpRect);
}

//To exclude child area,use style WS_CLIPCHILDREN not using ExcludeChildCtrl(hDC);
void KFCWnd::ExcludeChildCtrl(HDC hDC) /* non-flicker prevent drawing child window area */
{
	HWND hChild = GetWindow(m_hWnd,GW_CHILD);
	while(hChild){
		if(::IsWindow(hChild) && ::IsWindowVisible(hChild)){
			RECT rc;
			::GetWindowRect(hChild,&rc);
			ScreenToClient(&rc);
			ExcludeClipRect(hDC,rc.left,rc.top,rc.right,rc.bottom);
		}
		hChild = GetWindow(hChild,GW_HWNDNEXT);
	}
}

/*
  This called from KFCApp directly,If parent is modal dialog,this event wiil not be reached never 
 */
BOOL KFCWnd::PreTranslateMessage(MSG* pMsg)
{
	return FALSE;//FALSE TO Translate
}

LRESULT KFCWnd::Default()
{
	return DefWindowProc(m_hWnd,m_LastMsg.message,m_LastMsg.wParam,m_LastMsg.lParam);
}

LRESULT KFCWnd::DefWindowProc(HWND hWnd,UINT message, WPARAM wParam, LPARAM lParam)
{
	//ASSERT(hWnd == m_hWnd);
	if(m_fnSuper){
#ifdef STRICT
		return ::CallWindowProc(m_fnSuper, hWnd, message, wParam, lParam);
#else
		return ::CallWindowProc((FARPROC)m_fnSuper, m_hWnd, message, wParam, lParam);
#endif
	}
	return ::DefWindowProc(hWnd,message,wParam,lParam);
}

//TRUE if message was handled; otherwise FALSE.
//return value 1L = ignore default proc, 0L through default proc,
//pResult = if you want to pass other return value to default proc into kernel,
//set pResult to other value which neither 1L nor 0L.

BOOL KFCWnd::OnWndMsg(UINT message, WPARAM wParam, LPARAM lParam,LRESULT& lResult)
{
	BOOL bHandled = TRUE;
	
	m_LastMsg.message = message;
	m_LastMsg.wParam  = wParam;
	m_LastMsg.lParam  = lParam;
	m_LastMsg.hwnd    = m_hWnd;

	lResult = 0L;//An application should return zero if it processes this message.
	bHandled = ProcMsg(message,wParam,lParam,lResult);
	/*if(message == WM_CREATE || message == WM_INITDIALOG){
		//if(m_bFadeInCreated)
		//	StartFadeIn();
	}*/

	if(bHandled == 0){
		LRESULT lResult2 = 0;
		if((bHandled = ReflectNotifications(message,wParam,lParam,lResult2)))
			lResult = lResult2;
	}
	if(message == WM_NCDESTROY){
		/*
		old method for reflection message
		DelReflectMap();
		*/
	}
	else if(message == WM_DESTROY){
		/*if(m_FadeIO.bCreated && m_FadeIO.hThreadFadeIn != NULL){
			//StopFadeIn();
		}*/
		KFCApp *pApp = KFCGetApp();
		if(pApp){
			KFCWnd *pWin = (KFCWnd *)pApp->m_pMainWnd;
			if(pWin){
				HWND hwnd = pWin->GetSafeHwnd();
				if(m_hWnd == hwnd)
				PostQuitMessage(0);	
			}
		}
	}
	return bHandled;
}

HWND KFCWnd::GetReflectChild(UINT message, WPARAM wParam, LPARAM lParam)
{
	
//	if(message > 0xFFFF)
//		throw KFCException("strange message!!\n");

	HWND hWndChild = NULL;
	if(m_hWnd == NULL || !::IsWindow(m_hWnd))
		return NULL;

	switch(message)
	{
	case WM_COMMAND:
		if(lParam != NULL)	// not from a menu
			hWndChild = (HWND)lParam;
		break;
	case WM_NOTIFY:
		hWndChild = ((LPNMHDR)lParam)->hwndFrom;
		break;
	case WM_PARENTNOTIFY:
		switch(LOWORD(wParam))
		{
		case WM_CREATE:
		case WM_DESTROY:
			hWndChild = (HWND)lParam;
			break;
		default:
			hWndChild = ::GetDlgItem(m_hWnd,HIWORD(wParam));
			break;
		}
		break;
	case WM_DRAWITEM:
		//If child process WM_PAINT,WM_DRAWITEM event do not work normally,because BeginPaint() eat Update region.
		//So if want to process WM_DRAWITEM on child window,the child window don't process WM_PAINT event handler.
		if(wParam)	// not from a menu
			hWndChild = ((LPDRAWITEMSTRUCT)lParam)->hwndItem;
		break;
	case WM_MEASUREITEM:
		if(wParam)	// not from a menu
			hWndChild = ::GetDlgItem(m_hWnd,((LPMEASUREITEMSTRUCT)lParam)->CtlID);
		break;
	case WM_COMPAREITEM:
		if(wParam)	// not from a menu
			hWndChild =  ((LPCOMPAREITEMSTRUCT)lParam)->hwndItem;
		break;
	case WM_DELETEITEM:
		if(wParam)	// not from a menu  
			hWndChild =  ((LPDELETEITEMSTRUCT)lParam)->hwndItem;
		 
		break;
	case WM_VKEYTOITEM:
	case WM_CHARTOITEM:
	case WM_HSCROLL:
	case WM_VSCROLL:
		hWndChild = (HWND)lParam;
		break;
	case WM_CTLCOLORBTN:
	case WM_CTLCOLORDLG:
	case WM_CTLCOLOREDIT:
	case WM_CTLCOLORLISTBOX:
	case WM_CTLCOLORMSGBOX:
	case WM_CTLCOLORSCROLLBAR:
	case WM_CTLCOLORSTATIC:
		hWndChild = (HWND)lParam;
		break;
	default:
		break;
	}
	if(hWndChild){
#if 0
		HWND hWnd = FindReflectMap(hWndChild);
		if(hWnd)
			return hWndChild;
#else
		KFCWnd* pWnd = KFCWnd::FromHandle(hWndChild);
		if(pWnd)
			return hWndChild;
		else
			return NULL;
#endif
	}
	return hWndChild;
}

//KFCWnd 迭 ߰ų Ŭ 찡 ƴϸ ÷ ޼  ȵȴ.(⺻ νõ Ÿؾ Ѵ)
//Don't send ReflectChildNotifications to child which if not created as KFCWnd family and subclassed window.
//ذ: 	
//1) WNDPROC pProc = pThis->GetWindowProc();  (WNDPROC)GetWindowLongPtr(hWnd, GWLP_WNDPROC); Ͽ
//    KFCWnd  ǺѴ.׷ ѹ Ŭϰų ڰ ѹ ::SetWindowLongPtr(hWnd, GWLP_WNDPROC, (LONG_PTR)pProc);
//   ع ̰ pProc = pThis->GetWindowProc();  ġ Ƿ ۵  ϹǷ ̹ Ŭ Ŭ̵
//    쿡  ʴ.
//2) KFC_HANDLE_REFLECT_XXX ڵ鷯  KFCWnd Ŭ , ڵ ʿϰ ⿡ ˻Ͽ ִ  ÷
//   ó Ѵ.
//3) ̷ Ŀη     ƴ϶,  Ŭ Ʒ OnReflectChildNotifications  ޾,
//   ÷  ϵ Ѵ.
//4) 2) + 3)  ϰ  óѴ.

BOOL KFCWnd::OnReflectChildNotifications(UINT message, WPARAM wParam, LPARAM lParam)//determine if reflect child or not,TRUE = allow
{
	return TRUE;
}

//reflect message must have return bHandled or not in parent window procedure.
//if parent bHandled = FALSE,the message will be enterted in this function.

BOOL KFCWnd::ReflectNotifications(UINT message, WPARAM wParam, LPARAM lParam,LRESULT& lResult)
{
	BOOL bHandled = TRUE;
	HWND hWndChild = NULL;
	lResult = 0L;

	BOOL bDo = OnReflectChildNotifications(message,wParam,lParam);
	if(!bDo){
		bHandled = FALSE;
		return FALSE;
	}
	if((hWndChild = GetReflectChild(message,wParam,lParam)) == NULL){
		bHandled = FALSE;
		return FALSE;
	}

	ASSERT(::IsWindow(hWndChild));
#if 0
	lResult = ::SendMessage(hWndChild, KFC_REFLECT_BASE + message, wParam, lParam);
#else
	KFCWnd* pChildWnd = KFCWnd::FromHandle(hWndChild);
	bHandled = pChildWnd->ProcMsg(KFC_REFLECT_BASE + message,wParam,lParam,lResult);
#endif
	return bHandled;
}
#if 0 //old method
void KFCWnd::AddReflectMap()
{
	if(!m_hWnd || !::IsWindow(m_hWnd))
		return;

	if(m_nRefMap == 0){
		_KFCModule.AddReflectMap(m_hWnd);
	}
	m_nRefMap++;
}

void KFCWnd::DelReflectMap()
{
	if(!m_hWnd || !::IsWindow(m_hWnd))
		return;

	if(m_nRefMap != 0){
		_KFCModule.DelReflectMap(m_hWnd);
		m_nRefMap = 0;
	}
}

HWND KFCWnd::FindReflectMap(HWND hWnd)
{
	return _KFCModule.FindReflectMap(hWnd);
}

#endif
BOOL KFCWnd::DefaultReflectionHandler(UINT message, WPARAM wParam, LPARAM lParam, LRESULT& lResult)
{
	switch(message)
	{
	case KFC_REFLECT_BASE + WM_COMMAND:
	case KFC_REFLECT_BASE + WM_NOTIFY:
	case KFC_REFLECT_BASE + WM_PARENTNOTIFY:
	case KFC_REFLECT_BASE + WM_DRAWITEM:
	case KFC_REFLECT_BASE + WM_MEASUREITEM:
	case KFC_REFLECT_BASE + WM_COMPAREITEM:
	case KFC_REFLECT_BASE + WM_DELETEITEM:
	case KFC_REFLECT_BASE + WM_VKEYTOITEM:
	case KFC_REFLECT_BASE + WM_CHARTOITEM:
	case KFC_REFLECT_BASE + WM_HSCROLL:
	case KFC_REFLECT_BASE + WM_VSCROLL:
	case KFC_REFLECT_BASE + WM_CTLCOLORBTN:
	case KFC_REFLECT_BASE + WM_CTLCOLORDLG:
	case KFC_REFLECT_BASE + WM_CTLCOLOREDIT:
	case KFC_REFLECT_BASE + WM_CTLCOLORLISTBOX:
	case KFC_REFLECT_BASE + WM_CTLCOLORMSGBOX:
	case KFC_REFLECT_BASE + WM_CTLCOLORSCROLLBAR:
	case KFC_REFLECT_BASE + WM_CTLCOLORSTATIC:
		lResult = ::DefWindowProc(m_hWnd, message - OCM__BASE, wParam, lParam);
		return TRUE;
	default:
		break;
	}
	return FALSE;
}

BOOL KFCWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	m_bCreatedByMe = 1;
	return TRUE;	
}

BOOL KFCWnd::OnClose()
{
	//By default, the DefWindowProc function calls the DestroyWindow function to destroy the window.
	return FALSE;//pass to default,if no close,return TRUE;
}

void KFCWnd::OnDestroy(){}
void KFCWnd::OnNcDestroy(){}

//nState = WA_ACTIVE,WA_CLICKACTIVE,WA_INACTIVE
//hWndOther = If nState is WA_INACTIVE, lParam is the handle to the window being activated otherwise Deactived wnd.
//bMinimized = hWndOther 's status
void KFCWnd::OnActivate(UINT nState,HWND hWndOther,BOOL bMinimized)
{
	m_nActive++;
	if(nState == WA_ACTIVE && m_nActive == 1){
		OnFirstActive();
	}
}

void KFCWnd::OnFirstActive()
{

}

void KFCWnd::OnFinalMessage()
{

}

BOOL KFCWnd::OnSize(UINT state, int cx, int cy)
{
	return 0;//0 for default
}

BOOL KFCWnd::OnMove(int x, int y)
{
	return 0;//0 for default
}

BOOL KFCWnd::OnNCCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS * lpcsp,LRESULT &lResult)
{
	return 0;//0 for default
}

BOOL KFCWnd::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
	return 0;//0 for default
}

BOOL KFCWnd::OnWindowPosChanged(LPWINDOWPOS lpwndpos)
{
	return 0;//0 for default
}

BOOL KFCWnd::OnWindowPosChanging(LPWINDOWPOS lpwndpos)
{
	return 0;// 0 for default
}

void KFCWnd::OnPaint()
{
	/*
		For drawing,uncomment below,

		KFCPaintDC dc(m_hWnd); //cause WM_ERASEBKGND and WM_NCPAINT
		HDC hDC = dc.GetDC();

		if you handle WM_DRAWITEM also, do not handle WM_PAINT and call KFCPaintDC() or BeginPaint()
		BeginPaint() eat WM_DRAWITEM message by update invalid region,so WM_DRAWITEM message is not received from system normally.
		There is no alternative for your choice but to choose one of these (WM_PAINT or WM_DRAWITEM).

		typically,WM_DRAWITEM used for common control like as button,listbox,... for owner draw custom control.
		In this case,do not implements WM_PAINT event handler,do not call KFCPaintDC() , BeginPaint() here.
		BeginPaint()  ȣϸ ȿ Ʈ    WM_DRAWITEM ̺Ʈ ý   ȣ ȵȴ.
		,Owner Draw Ʈ ۼÿ WM_PAINT ó  ʰų BeginPaint,ȣ  Ѵ.

     */

}

BOOL KFCWnd::OnNcPaint(HRGN hRgn)
{
	//HDC hdc;
    //hdc = GetDCEx(m_hWnd, (HRGN)wParam, DCX_WINDOW|DCX_INTERSECTRGN);
    // Paint into this DC
    //ReleaseDC(m_hWnd, hdc);
	//if you edit your code, return 1
	return 0;//0=The DefWindowProc function paints the window frame.
}

BOOL KFCWnd::OnEraseBkgnd(HDC hDC)
{
	/*
	OnPaint  BeginPaint ȣ ȴ WM_PAINT  return 0 ̾
	If you implement OnPaint,return TRUE.
	*/
	// ׸ TRUE,ý ׸ ϸ Default Window νõ ۵ǵ FALSE Ѵ.
	//Default Window νõ Ÿ   OnPaint   Ѵ.
	//If return TRUE and so do not pass to Default Window Proc,you must erase yourself here now.
	//If return TRUE then WM_CTLCOLORDLG is not receive into your OnCtlColor.
	//If Erase background here,return TRUE for no more need erase it,
	//otherwise return FALSE to Default Window Proc erase it by hbrBackground brush of WNDCLASS
	//To exclude child area,use style WS_CLIPCHILDREN not using ExcludeChildCtrl(hDC);
	return FALSE;//Pass to default window proc to erase it now. In this case,we must call DefWindowProc.
}

BOOL KFCWnd::OnMeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct)
{
	if(lpMeasureItemStruct->CtlType == ODT_MENU){
		if(gfp_MeasureItem)/* kxNSMenu  ʴµ linkǾ ũⰡ Ŀ° ϱ */
			return gfp_MeasureItem(lpMeasureItemStruct);
		//return kxNSMenu::OnMeasureItem(lpMeasureItemStruct);
	}
	return 0;
}

BOOL KFCWnd::OnDrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	//If an application processes this message, it should return TRUE. 
	//By default, the DefWindowProc function draws the focus rectangle for an owner-drawn item. 
	if(lpDrawItemStruct->CtlType == ODT_MENU){
		//if(kxNSMenu::OnDrawItem(lpDrawItemStruct))
		if(gfp_DrawItem)/* kxNSMenu  ʴµ linkǾ ũⰡ Ŀ° ϱ */
			gfp_DrawItem(lpDrawItemStruct);
				return 1;
	}
	return 0;
}

BOOL KFCWnd::OnCompareItem(LPCOMPAREITEMSTRUCT lpCompareItem,LRESULT &lResult)
{
	return 0;//not Handled
}

BOOL KFCWnd::OnDeleteItem(LPDELETEITEMSTRUCT lpDeleteItem)//TRUE if Handled
{
	return 0;//not Handled
}

void KFCWnd::OnSetFocus(HWND hwndOldFocus){}
void KFCWnd::OnKillFocus(HWND hwndNewFocus){}

BOOL KFCWnd::OnSetCursor(HWND hWndCursor,UINT nHitTest,UINT message)
{
	//Nonzero to halt further processing, or 0 to continue.
	return FALSE;
}

//WM_GET DLGCODE will be received by control directly.
UINT KFCWnd::OnGetDlgCode(LPMSG lpMsg)
{
	return DLGC_WANTARROWS | DLGC_WANTCHARS;
}

BOOL KFCWnd::OnCommand(UINT nID, HWND hWndCtrl, UINT nNotifyCode)
{
	//if nID == 1 ,IDOK or ENTER key
	//nNotifyCode == Notify message  from an accelerator = 1,from a menu = 0
	//hWndCtrl = from a control = ctrl handle Otherwise  = NULL
	switch(nID){
	case IDOK:
	case IDCANCEL:
		break;
	default:
		break;
	}
	return 0;
}

BOOL KFCWnd::OnSysCommand(UINT nID,int x,int y)
{
	return 0;
}

BOOL KFCWnd::OnNotify(int idCtrl,LPNMHDR lpnmh,LRESULT &lResult)
{
	//HWND hWndFrom = lpnmh->hwndFrom;
	lResult = 0L;
	//if(lpNM->idFrom == IDC_BROWSE_TREE)
	//	return OnNotifyTreeCtrl(hWnd,wParam,lParam);
	return 0;
}

BOOL KFCWnd::OnLButtonDown(UINT nFlags,POINT point)
{
	return FALSE;
}

BOOL KFCWnd::OnLButtonUp(UINT nFlags,POINT point)
{
	return FALSE;
}

BOOL KFCWnd::OnLButtonDblClk(UINT nFlags,POINT point)
{
	return FALSE;
}

BOOL KFCWnd::OnRButtonDown(UINT nFlags,POINT point)
{
	return FALSE;
}

BOOL KFCWnd::OnRButtonUp(UINT nFlags,POINT point)
{
	return FALSE;
}

BOOL KFCWnd::OnRButtonDblClk(UINT nFlags,POINT point)
{
	return FALSE;
}

BOOL KFCWnd::OnMouseMove(UINT nFlags,POINT point)
{
	return FALSE;
}


BOOL KFCWnd::OnMouseWheel(UINT nFlags, short zDelta,POINT point)
{
	// Mouse wheel event.  zDelta is in multiples of 120.
	// Divide by 40 so each click is 3 lines.  I know some
	// drivers let you set the ammount of scroll, but I
	// don't know how to retrieve this or if they just
	// adjust the zDelta you get here.
	//If an application processes this message, it should return zero. 
	return FALSE;
}

BOOL KFCWnd::OnMouseHWheel(UINT nFlags, short zDelta,POINT point)
{
	// Mouse wheel event.  zDelta is in multiples of 120.
	// Divide by 40 so each click is 3 lines.  I know some
	// drivers let you set the ammount of scroll, but I
	// don't know how to retrieve this or if they just
	// adjust the zDelta you get here.
	//If an application processes this message, it should return zero. 
	return FALSE;
}

BOOL KFCWnd::OnMouseLeave()
{
	return FALSE;
}

BOOL KFCWnd::OnContextMenu(HWND hFocus,POINT point)
{
	return FALSE;
}

BOOL KFCWnd::OnCaptureChanged(HWND hNewCapture)//hNewCapture is the window to gain mouse capture
{
	return FALSE;
}

BOOL KFCWnd::OnNcHitTest(POINT point,LRESULT &lResult)
{
	return FALSE;

}

BOOL KFCWnd::OnNcLButtonDown(UINT nHitTest,POINT point)
{
	return FALSE;
}

BOOL KFCWnd::OnNcLButtonDblClk(UINT nHitTest,POINT point)
{
	return FALSE;
}

BOOL KFCWnd::OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags)
{
	BOOL bShift   = ((GetKeyState(VK_SHIFT) & 0x8000) != 0);
	//BOOL bControl = ((GetKeyState(VK_CONTROL) & 0x8000) != 0);
	//BOOL bAlt     = ((GetKeyState(VK_MENU) & 0x8000) != 0);
	switch(nChar){
	case VK_TAB:
		(bShift) ? PrevDlgCtrl(::GetParent(m_hWnd)) : NextDlgCtrl(::GetParent(m_hWnd));
		break;
	}
	return 0;
}

BOOL KFCWnd::OnKeyUp(UINT nChar,UINT nRepCnt,UINT nFlags)
{
	return 0;
}

BOOL KFCWnd::OnChar(UINT nChar,UINT nRepCnt,UINT nFlags)
{
	return 0;
}

void KFCWnd::OnTimer(UINT_PTR nIDEvent){}
BOOL KFCWnd::OnQueryEndSession()
{
	//Applications should respect the user's intentions and return TRUE. 
	//By default, the DefWindowProc function returns TRUE for this message.
	//TRUE = close app, FALSE = prevent close
	return TRUE;
}

BOOL KFCWnd::OnVkeyToItem(UINT vk, HWND hwndListbox, int iCaret,LRESULT &lResult)
{
	lResult = -1L;
	return 0;
}

BOOL KFCWnd::OnCharToItem(UINT ch, HWND hwndListbox, int iCaret,LRESULT &lResult)
{
	lResult = -1L;
	return 0;
}

BOOL KFCWnd::OnHScroll(UINT nSBCode,UINT nPos,HWND hWndBar)
{
	return 0;
}

BOOL KFCWnd::OnVScroll(UINT nSBCode,UINT nPos,HWND hWndBar)
{
	return 0;
}

BOOL KFCWnd::OnSettingChange(UINT nFlags,LPCTSTR lpszSection)
{
	return 0;
}

BOOL KFCWnd::GetScrollInfo(int nBar, LPSCROLLINFO lpScrollInfo)// throw()
{
	ASSERT(::IsWindow(m_hWnd));
	return ::GetScrollInfo(m_hWnd, nBar, lpScrollInfo);
}

int KFCWnd::SetScrollInfo(int nBar, LPSCROLLINFO lpScrollInfo, BOOL bRedraw)// throw()
{
	ASSERT(::IsWindow(m_hWnd));
	return ::SetScrollInfo(m_hWnd, nBar, lpScrollInfo, bRedraw);
}

int KFCWnd::ScrollWindowEx(int dx, int dy, LPCRECT lpRectScroll, LPCRECT lpRectClip, HRGN hRgnUpdate, LPRECT lpRectUpdate, UINT uFlags)// throw()
{
	ASSERT(::IsWindow(m_hWnd));
	return ::ScrollWindowEx(m_hWnd, dx, dy, lpRectScroll, lpRectClip, hRgnUpdate, lpRectUpdate, uFlags);
}

int KFCWnd::ScrollWindowEx(int dx, int dy, UINT uFlags, LPCRECT lpRectScroll, LPCRECT lpRectClip, HRGN hRgnUpdate, LPRECT lpRectUpdate)// throw()
{
	ASSERT(::IsWindow(m_hWnd));
	return ::ScrollWindowEx(m_hWnd, dx, dy, lpRectScroll, lpRectClip, hRgnUpdate, lpRectUpdate, uFlags);
}

int KFCWnd::SetScrollPos(int nBar, int nPos, BOOL bRedraw)// throw()
{
	ASSERT(::IsWindow(m_hWnd));
	return ::SetScrollPos(m_hWnd, nBar, nPos, bRedraw);
}

BOOL KFCWnd::SetScrollRange(int nBar, int nMinPos, int nMaxPos, BOOL bRedraw)// throw()
{
	ASSERT(::IsWindow(m_hWnd));
	return ::SetScrollRange(m_hWnd, nBar, nMinPos, nMaxPos, bRedraw);
}

BOOL KFCWnd::ShowScrollBar(UINT nBar, BOOL bShow)// throw()
{
	ASSERT(::IsWindow(m_hWnd));
	return ::ShowScrollBar(m_hWnd, nBar, bShow);
}

BOOL KFCWnd::EnableScrollBar(UINT uSBFlags, UINT uArrowFlags)// throw()
{
	ASSERT(::IsWindow(m_hWnd));
	return ::EnableScrollBar(m_hWnd, uSBFlags, uArrowFlags);
}

void KFCWnd::OnCancelMode(){}//it is called when a dialog box or message box is displayed.This gives we the opportunity to cancel modes such as mouse capture.
void KFCWnd::OnEnableWindow(BOOL bEnable){}
void KFCWnd::OnDropFiles(HDROP hDropInfo){}
void KFCWnd::OnFontChange(){}

/*bActive = TRUE,dwThreadID is deactivated window threadid*/
void KFCWnd::OnActivateApp(BOOL bActive,DWORD dwThreadID)
{
}
void KFCWnd::OnSysColorChange(){}
void KFCWnd::OnSetText(LPTSTR szNewText){}
int  KFCWnd::OnGetText(int cchTextMax, LPTSTR lpszText)
{
	return 0;//0 to default
}

BOOL KFCWnd::OnSetFont(HFONT hFont, BOOL bRedraw)
{
	return 0;
}

BOOL KFCWnd::OnGetFont(HFONT & hFont)
{
	return 0;
}

LRESULT KFCWnd::OnIMEStartComposition(WPARAM wParam, LPARAM lParam) /*toggle IME mode - begin*/
{
	//bIMEComposition = TRUE
	return 0L;//0L = through default window procedure,1L = ignore
}
LRESULT KFCWnd::OnIMEEndComposition(WPARAM wParam, LPARAM lParam) /*toggle IME mode - end*/
{
	//bIMEComposition = FALSE
	return 0L;//0L = through default window procedure,1L = ignore
}

LRESULT KFCWnd::OnIMESetContext(WPARAM wParam, LPARAM lParam)  /*called when initilize IME or ACTIVATE own window.*/
{
#if 0
	//example code ------------------------------------------------------
	//ٸâ ȯ  ͽ / IME° Ӱ  Ȱ
	//  IME¿ ° Ѵ.
	// Ŭϸ ȵǴ.콺 ȣƮĿ ̵ϰ
	//Editâ Ŭϸ dll chkKeyMode() Ÿ⶧ ڵȯ Ǿ,
	// Ŭϰų tabbar Ŭϰų 콺 ⺻ ѻ·
	//â ȯϸ â ime¸  ־ ̸ ٽ ǿ ° ϰ.
	//2003.06.13 krkim
	BOOL bActive = (BOOL)wParam;//window active
	//if(bActive) //auto toggle IME Han/Eng mode
	//{
	//	int flag = (CFG.m_IMEConfig.nToggleMask & IL_IMESESSIONTOGGLE) ? TRUE : FALSE;
	//	if(flag)
	//		NSA_SetActiveSession(TRUE);
	//}
	lParam = lParam & ~ISC_SHOWUICOMPOSITIONWINDOW; //ջ¸ IMECOMPâ̾ƴ α׷.(into composition status to my window)
	//lParam = lParam & ~ISC_SHOWUIALLCANDIDATEWINDOW;//̰ clearϸ CANDIDATE WINDOW ȶ.(â)

	int flag;
	HWND hwndIME = ImmGetDefaultIMEWnd(m_hWnd);
	flag = ImmIsUIMessage(hwndIME,WM_IME_SETCONTEXT, wParam, lParam);
#endif
	return 0L;//0L = through default window procedure,1L = ignore
}

LRESULT KFCWnd::OnIMEComposition(WPARAM wParam, LPARAM lParam) /*called when doing composite or complete DBCS */
{
	//example code ------------------------------------------------------
#if 0
	char szDBCS[3]={0,};
	WORD chDBCS = (WORD)wParam;
	int fFlags = (BOOL) lParam;
	szDBCS[0] = (chDBCS >> 8) & 0XFF;
	szDBCS[1] = (chDBCS ) & 0XFF;
	wsprintf(szmsg,"OnIMEComposition:chDBCS=[%s]%04X,flags =%04x\n",szDBCS,chDBCS,fFlags);
	OutputDebugString(szmsg);
	//Before processing WM_IME_CHAR ,bug after DBCS input and DBCS space or numeric.
	if(fFlags & GCS_RESULTSTR){//conform DBCS code
		//result ? no send here ,instead send in WM_IME_CHAR
		//WM_IME_CHAR is always RESULTSTRING with DBCS space or numeric and COMPOSITION CHAR.
	}
	//COMMENT 2003 05 09
	if(chDBCS == 0x0000)//FOR DELETE HANGUL DBCS Code ,,send once time 0x00
	{
		//Է 齺̽  .
	}
#endif
	return 0L;//0L = through default window procedure,1L = ignore
}

LRESULT KFCWnd::OnIMENotify(WPARAM wParam, LPARAM lParam)
{
#if 0
	//example code ------------------------------------------------------
	DWORD fCandidate;
	switch(wParam)
	{

	case IMN_OPENSTATUSWINDOW:
	case IMN_CLOSESTATUSWINDOW:
	case IMN_SETOPENSTATUS:
		break;
	case IMN_SETCONVERSIONMODE: /* /  toggle HAN/ENG*/
		{
			DWORD	dwConversion;
			DWORD	dwSentence;  

			HIMC		hIMC;
			HWND		hWnd = this->m_hWnd;
			hIMC = ::ImmGetContext(hWnd);

			BOOL nMode = ::ImmGetOpenStatus(hIMC);///,/,/ϰ 1,/ 0
			ImmGetConversionStatus(hIMC, &dwConversion, &dwSentence);                      
			::ImmReleaseContext(hWnd, hIMC); 
			//dwConversion & IME_CMODE_HANGEUL ѱ۸
			//wsprintf(szmsg,"WM_IME_NOTIFY:nMode = %d dwConversion=0x%02x -> 0x%02x wParam(%x),lParam(%x)\n",nMode,m_dwConversion,dwConversion,wParam,lParam);
			//OutputDebugString(szmsg);

			//ѱ߿ Ű 0x49 ,IME_CMODE_HANJACONVERT ´.
			if(dwConversion & IME_CMODE_HANJACONVERT)//0x40
			{}

			//ڼ ϵɶ 0x09 , m_dwConversion IME_CMODE_HANJACONVERT ִ.
			//if(m_dwConversion & IME_CMODE_HANJACONVERT)
			//{}
			// ΰ 츦 ŵؾ / ۽ Ű / ۹
			//Է / ۹.

			int prevfullmode = 0,curfullmode = 0;
			//prevfullmode =  m_dwConversion & IME_CMODE_FULLSHAPE;
			curfullmode =  dwConversion & IME_CMODE_FULLSHAPE;

			if(prevfullmode != curfullmode){
				//wKeyCode = API_JUNJA;
			}
			//m_dwConversion = dwConversion;
		}
		break;
	case IMN_OPENCANDIDATE://HANJA window
		fCandidate = (DWORD)lParam;//bit 0 -> higher bit (list index is opened or not)
#if 0		
		if(m_bInIMECandidate)//fCandidate != 0x01)
		{
			CANDIDATEFORM cdf;
			HIMC          hIMC;

			hIMC = ImmGetContext(m_hWnd);
			CPoint curpos;
			curpos = GetCursorPos();
			curpos = TextToClient(curpos);
			cdf.dwIndex = 0;
			cdf.dwStyle = CFS_CANDIDATEPOS;
			//cdf.ptCurrentPos.x = (curpos.x * lpStruct->tm.tmAveCharWidth) + m_szEditGap.cx;
			//cdf.ptCurrentPos.y = ((curpos.y + 1) * lpStruct->tm.tmHeight+2) + m_szEditGap.cy;
			cdf.ptCurrentPos.x = (curpos.x);// + m_szEditGap.cx;
			cdf.ptCurrentPos.y = (curpos.y + 20);
			ImmSetCandidateWindow(hIMC,&cdf);
			ImmReleaseContext(m_hWnd,hIMC);
		}
#endif
		break;
	case IMN_CLOSECANDIDATE:
		{
			//HWND hWnd = CHILD_GetEditWindow();
			//HIMC hIMC = ::ImmGetContext(hWnd);
			//DWORD	dwConversion;
			//DWORD	dwSentence;  
			//ImmGetConversionStatus(hIMC, &dwConversion, &dwSentence);
			//if(m_dwIMEConversionMode != dwConversion)
			//{
			//	ImmSetConversionStatus(hIMC,m_dwIMEConversionMode,IME_SMODE_NONE);
			//}
			//::ImmReleaseContext(m_hWnd, hIMC); 
		}
		break;
	}
#endif
	return 0L;//0L = through default window procedure,1L = ignore
}

UINT KFCWnd::InvokeIMECommand(WPARAM wParam, LPARAM lParam)/* IME   */
{
	UINT wReturn = 0;
	HIMC	hIMC;
	HWND	hWnd = this->m_hWnd;
	DWORD	dwConversion;
	DWORD	dwSentence;  

	hIMC = ::ImmGetContext(hWnd);

	DWORD dwValue= 0;	
	BYTE bComp[10]={0,};
	BYTE rRead[10]={0,};
	WORD code = (WORD)wParam;
	int flag1,flag3;

	switch ((UINT)lParam)
	{
	case IME_COMMAND_HANJACONVERT://Ű´(ںȯŸ־ش)
		bComp[0] = HIBYTE(code);
		bComp[1] = LOBYTE(code);
		flag1 = ImmGetConversionStatus(hIMC, &dwConversion, &dwSentence);
		/*m_dwIMEConversionMode = dwConversion;*/
		//flag2 = ImmSetConversionStatus( hIMC, IME_CMODE_NATIVE, IME_SMODE_NONE);//must be HANGUL NATIVE MODE for GOODWORK
		flag3 = ImmSetCompositionString(hIMC,SCS_SETSTR,bComp,2,rRead,2);
		ImmNotifyIME(hIMC,NI_OPENCANDIDATE,CPS_CONVERT,dwValue);//open candidate window(hanja list);
		//wsprintf(szmsg,"InvokeIMECommand:MY_IME_HANJACONVERT dwConversion=%d flags =%d %d %d\n",dwConversion,flag1,flag2,flag3);
		break;

	case IME_COMMAND_GETCONVERSIONSTATUS://ۻ¾
		{  
			BOOL nMode;
			nMode = ::ImmGetOpenStatus(hIMC);///,/,/ϰ 1,/ 0
			ImmGetConversionStatus(hIMC, &dwConversion, &dwSentence);                      
			//dwConversion & IME_CMODE_HANGEUL ѱ۸
			wReturn = dwConversion;			  	
			//			wsprintf(szmsg,"InvokeIMECommand:MY_IME_GETCONVERSIONSTATUS nMode = %d dwConversion=0x%02x\n",nMode,dwConversion);
		}	
		break;

	case IME_COMMAND_SETCONVERSIONSTATUS://۽Ű
		{  
			BOOL nMode,nMode2;
			nMode = ::ImmGetOpenStatus(hIMC);// = IMN_SETOPENSTATUS
			dwConversion =  wParam;//IME_CMODE_ALPHANUMERIC,IME_CMODE_NATIVE,IME_CMODE_FULLSHAPE
			ImmSetConversionStatus( hIMC, dwConversion, IME_SMODE_NONE);
			nMode2 = ::ImmGetOpenStatus(hIMC);
			//			wsprintf(szmsg,"InvokeIMECommand:MY_IME_SETCONVERSIONSTATUS nMode = %d -> %d dwConversion=0x%02x\n",nMode,nMode2,dwConversion);
		}
		break;

	case IME_COMMAND_AUTOMATIC://ڵ
		//ImmSetConversionStatus( hIMC, IME_CMODE_NOCONVERSION,IME_SMODE_AUTOMATIC);
		//			wsprintf(szmsg,"InvokeIMECommand:MY_IME_AUTOMATIC IME_CMODE_NOCONVERSION\n");
		break;
	}
	::ImmReleaseContext(hWnd, hIMC); 
	return wReturn;
}

LRESULT KFCWnd::OnIMEChar(WPARAM wParam, LPARAM lParam)  /*called when complete DBCS */
{
	//example code ------------------------------------------------------
#if 0
	BOOL bAlphaNumeric = FALSE;

	char szDBCS[3]={0,};
	WORD chDBCS = (WORD)wParam;
	int fFlags = (BOOL) lParam;
	szDBCS[0] = (chDBCS >> 8) & 0XFF;
	szDBCS[1] = (chDBCS ) & 0XFF;

	if((chDBCS >= 0xA3A1 && chDBCS <= 0xA3C0) || chDBCS == 0xA1A1)
	{
		bAlphaNumeric = TRUE;
	}

	byCtrl = BYC_NORMAL;	

	UINT wMode = InvokeIMECommand(0,(LPARAM)IME_COMMAND_GETCONVERSIONSTATUS);
	int fullmode = 0;
	if(wMode & IME_CMODE_FULLSHAPE) //
		fullmode = 1;

	wsprintf(szmsg,"WM_IME_CHAR=%xh(%d) wParam = [%s]%Xh lParam =%Xh,Full Shape Mode = %d\n",message,message,szDBCS,wParam,lParam,fullmode);
	OutputDebugString(szmsg);
	if(fullmode == 0)//ڸ ȯȻε ڰ ̹ °
	{
		BOOL bControlAlphaNumeric = true;
		if(bAlphaNumeric && bControlAlphaNumeric) /*ڸ忡 ڼ/ȣ Է ڷκȯ ?*/
		{
			char chSingle;
			chSingle = 0x21 + (chDBCS - 0xA3A1);
			if(chDBCS == 0xA1A1)
				chSingle = 0x20;
			TCHAR chars[3];
			chars[0] = chSingle;
			//PutMBCS(chars,false,true);
			PutChar(chSingle,false,false);
			break;
		}
	}
	if(szDBCS[0] == 0x00 || !IsDBCSLeadByte(szDBCS[0])){
		PutChar(szDBCS[1],false,false);
		break;
	}
	PutChar(szDBCS[0],true,false);
	PutChar(szDBCS[1],true,true);
	//PutMBCS(szDBCS,true,true);
#endif
	// ڵ忡 ϸ ̰  1L  Ұ - in your implement code,return 1L
	return 0L;//0L = through default window procedure,1L = ignore
}

LRESULT KFCWnd::OnIMEKeyDown(WPARAM wParam, LPARAM lParam) /*called when doing composite ,PRESS VIRTUAL KEY like as arrow.. */
{   /*ѱԷ߿ ȭǥŰ ų Ű ߻*/
	return 0L;//through default window procedure
}

HBRUSH KFCWnd::OnCtlColor(HDC hDC,HWND hChild,UINT nCtlColor)
{
	//static HBRUSH h = (HBRUSH)::CreateSolidBrush(GetSysColor(COLOR_3DFACE));
	//switch(nCtlColor)
	//{
	//	case CTLCOLOR_BTN: 		break;
	//	case CTLCOLOR_STATIC: 	break;
	//	case CTLCOLOR_DLG: 		break;
	//	case CTLCOLOR_EDIT:
	//		h = (HBRUSH)::CreateSolidBrush(GetSysColor(COLOR_WINDOW));
	//		break;
	//}
	//return (LRESULT)GetStockObject(NULL_BRUSH);
	//m_tbrush = (HBRUSH)GetStockObject( HOLLOW_BRUSH );
	//m_headerbkbrush = (HBRUSH)::CreateSolidBrush(cfg.m_headerbkcolor);
	//By default, the DefWindowProc function selects the default system colors 
	return 0;// return 0 to by default or send to reflect notification to control;
}

BOOL KFCWnd::SubMenuSystem(HMENU hPopupMenu)
{
	MENUITEMINFO mii;
	mii.cbSize = sizeof(MENUITEMINFO); // must fill up this field
#ifdef FIXBUG
	mii.cbSize = GetSizeofMenuItemInfo();
#endif

	mii.fMask = MIIM_ID;             // get the state of the menu item
	return (BOOL)GetMenuItemInfo( hPopupMenu, SC_CLOSE, FALSE,&mii);
}

void KFCWnd::OnInitMenu(HMENU hMenu)
{
	//EnableMenuItem( (HMENU)wParam, IDM_LOGIN, MF_BYCOMMAND|MF_ENABLED );
}

void KFCWnd::OnInitMenuPopup(HMENU hPopupMenu,UINT nIndex,BOOL bSysMenu)
{
	BOOL IsSysMenu = SubMenuSystem(hPopupMenu);
	//KFCTRACE("[%lu]WM_INITMENUPOPUP:hPopupMenu=%x nIndex = %d,bSysMenu=%d,IsSysMenu=%d\n",
	//	GetTickCount() % 1000,hPopupMenu,nIndex,bSysMenu,IsSysMenu);
	//krkim
	if(gfp_InitMenuPopup)/* kxNSMenu  ʴµ linkǾ ũⰡ Ŀ° ϱ */
		gfp_InitMenuPopup(m_hWnd,hPopupMenu, nIndex, bSysMenu);

	//if(!kxNSMenu::OnInitMenuPopup(m_hWnd,hPopupMenu, nIndex, bSysMenu)){

	//}
}

void KFCWnd::OnMenuSelect(UINT nItemID,UINT nFlags,HMENU hSysMenu)
{
	//HMENU hmenuPopup = (nFlags & MF_POPUP) ? GetSubMenu(hSysMenu,nItemID) : 0;
}

BOOL KFCWnd::OnMenuChar(UINT nChar,UINT nFlags,HMENU hMenu,LRESULT & lResult)
{
	//high-order word of lResult = MNC_IGNORE,MNC_CLOSE,MNC_EXECUTE,MNC_SELECT if return TRUE;
	return 0;
}

void KFCWnd::OnEnterMenuLoop(BOOL bIsTrackPopupMenu){}
void KFCWnd::OnExitMenuLoop(BOOL bIsTrackPopupMenu){}

void KFCWnd::CenterWindow(HWND hWndAlter)
{
	HWND hWnd = m_hWnd;
	DWORD dwStyle = GetWindowLongPtr(hWnd, GWL_STYLE);
	HWND hWndCenter = hWndAlter;
	RECT rcDlg;
	RECT rcArea;
	RECT rcCenter;
	HWND hWndParent;
	//struct MONITORINFO mi;
	int w,h;
	int xLeft,yTop;

	::GetWindowRect(hWnd,&rcDlg);
	/*if(hWndCenter == NULL){*/
		if(dwStyle & WS_CHILD)
			hWndCenter = ::GetParent(hWnd);
		else
			hWndCenter = ::GetWindow(hWnd, GW_OWNER);
	/*}*/
	// get coordinates of the window relative to its parent
	//mi.cbSize = sizeof(mi);

	if (!(dwStyle & WS_CHILD))
	{
		// don't center against invisible or minimized windows
		if (hWndCenter != NULL)
		{
			DWORD dwStyle = ::GetWindowLongPtr(hWndCenter, GWL_STYLE);
			if (!(dwStyle & WS_VISIBLE) || (dwStyle & WS_MINIMIZE))
				hWndCenter = NULL;
		}
		rcArea.left=0;
		rcArea.top=0;
		rcArea.right=GetSystemMetrics(SM_CXSCREEN);
		rcArea.bottom=GetSystemMetrics(SM_CYSCREEN);
#if 1
		HMONITOR hMonitor;
		MONITORINFO mi;
		//
		// get the nearest monitor to the passed rect.
		//
		if(hWndCenter)
			hMonitor = MonitorFromWindow(hWndCenter, MONITOR_DEFAULTTONEAREST);
		else
			hMonitor = MonitorFromRect(&rcDlg, MONITOR_DEFAULTTONEAREST);
		//
		// get the work area or entire monitor rect.
		//
		mi.cbSize = sizeof(mi);
		GetMonitorInfo(hMonitor, &mi);
		rcArea = mi.rcMonitor;
#endif

		if(hWndCenter !=NULL)
			::GetWindowRect(hWndCenter, &rcCenter);
		else
			rcCenter = rcArea;
	}
	else
	{
		// center within parent client coordinates
		hWndParent = ::GetParent(hWnd);
		//ASSERT(IsWindow(hWndParent));

		::GetClientRect(hWndParent, &rcArea);
		::GetClientRect(hWndCenter, &rcCenter);
		MapWindowPoints(hWndCenter, hWndParent, (POINT*)&rcCenter, 2);
	}

	w = rcDlg.right -rcDlg.left;
	h = rcDlg.bottom -rcDlg.top;
	// find dialog's upper left based on rcCenter
#if 0
	xLeft = (rcCenter.left + rcCenter.right) / 2 - w/ 2;
	yTop = (rcCenter.top + rcCenter.bottom) / 2 - h/ 2;
#else
	xLeft   = rcCenter.left + (rcCenter.right  - rcCenter.left - w) / 2;
	yTop    = rcCenter.top  + (rcCenter.bottom - rcCenter.top  - h) / 2;
#endif
	// if the dialog is outside the screen, move it inside
	if (xLeft < rcArea.left)
		xLeft = rcArea.left;
	else if (xLeft + w > rcArea.right)
		xLeft = rcArea.right - w;

	if (yTop < rcArea.top)
		yTop = rcArea.top;
	else if (yTop + h > rcArea.bottom)
		yTop = rcArea.bottom - h;

	// map screen coordinates to child coordinates
	SetWindowPos(NULL, xLeft, yTop, -1, -1,
	//SWP_DRAWFRAME   Ӵٿ ޺ڽ Ŀ  ȵȴ.̷,MoveWindow üѴ.	
		SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
}

//
//  ClipOrCenterRectToMonitor
//
//  The most common problem apps have when running on a
//  multimonitor system is that they "clip" or "pin" windows
//  based on the SM_CXSCREEN and SM_CYSCREEN system metrics.
//  Because of app compatibility reasons these system metrics
//  return the size of the primary monitor.
//
//  This shows how you use the multi-monitor functions
//  to do the same thing.
//
//do not include multimon.h(LINK ERROR)
void KFCWnd::GetScreenRectToMonitor(LPRECT prc, UINT flags)
{
	HMONITOR hMonitor;
	MONITORINFO mi;
	RECT        rc;
	int         w = prc->right  - prc->left;
	int         h = prc->bottom - prc->top;

	//
	// get the nearest monitor to the passed rect.
	//
	hMonitor = MonitorFromRect(prc, MONITOR_DEFAULTTONEAREST);

	//
	// get the work area or entire monitor rect.
	//
	mi.cbSize = sizeof(mi);
	GetMonitorInfo(hMonitor, &mi);

	if (flags & MONITOR_WORKAREA)
		rc = mi.rcWork;
	else
		rc = mi.rcMonitor;

	//
	// center or clip the passed rect to the monitor rect
	//
	if (flags & MONITOR_CENTER)
	{
		prc->left   = rc.left + (rc.right  - rc.left - w) / 2;
		prc->top    = rc.top  + (rc.bottom - rc.top  - h) / 2;
		prc->right  = prc->left + w;
		prc->bottom = prc->top  + h;
	}
	else if (flags & MONITOR_CLIP)// ǥ CLIP
	{
		prc->left   = max(rc.left, min(rc.right-w,  prc->left));
		prc->top    = max(rc.top,  min(rc.bottom-h, prc->top));
		prc->right  = prc->left + w;
		prc->bottom = prc->top  + h;
	}
	else
		*prc = rc;//just get.
}

void KFCWnd::GetWindowRectToMonitor(LPRECT prc,UINT flags)
{
	::GetWindowRect(m_hWnd,prc);
	GetScreenRectToMonitor(prc,flags);
}

void KFCWnd::MoveWindowToMonitor(UINT flags)
{
	RECT rc;
	::GetWindowRect(m_hWnd, &rc);
	GetScreenRectToMonitor(&rc, flags);
	SetWindowPos(NULL, rc.left, rc.top, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
}

void KFCWnd::MoveWindow(RECT rc,BOOL bRepaint)
{
	::MoveWindow(m_hWnd,rc.left,rc.top,rc.right - rc.left,rc.bottom - rc.top,bRepaint);
}

void KFCWnd::MoveCtrl(UINT nID,int diffx,int diffy)
{
	RECT rc;
	::GetWindowRect(::GetDlgItem(m_hWnd,nID),&rc);
	ScreenToClient(&rc);
	::SetWindowPos(::GetDlgItem(m_hWnd,nID),NULL,rc.left + diffx,rc.top + diffy,0,0,SWP_NOACTIVATE|SWP_NOSIZE|SWP_NOZORDER|SWP_DRAWFRAME);
}

void KFCWnd::ResizeCtrl(UINT nID,int diffx,int diffy)
{
	ResizeWindow(::GetDlgItem(m_hWnd,nID),diffx,diffy);
}

void KFCWnd::ResizeWindow(HWND hWnd,int diffx,int diffy)
{
	RECT rw;
	::GetWindowRect(hWnd,&rw);
	::SetWindowPos(hWnd,NULL,-1,-1,RECTWIDTH(rw) + diffx,RECTHEIGHT(rw) + diffy,SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOZORDER|SWP_DRAWFRAME);
}

void KFCWnd::CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType)
{
	DWORD dwExStyle = GetExStyle();
	if (nAdjustType == 0)
		dwExStyle &= ~WS_EX_CLIENTEDGE;
	::AdjustWindowRectEx(lpClientRect, GetStyle(), FALSE, dwExStyle);
}

void KFCWnd::RepositionWindow(KX_SIZEPARENTPARAMS* lpLayout,HWND hWnd, LPCRECT lpRect,UINT nFlags)
{
	ASSERT(hWnd != NULL);
	ASSERT(lpRect != NULL);
	HWND hWndParent = ::GetParent(hWnd);
	ASSERT(hWndParent != NULL);

	if (lpLayout != NULL && lpLayout->hDWP == NULL)
		return;

	// first check if the new rectangle is the same as the current
	kxRect rectOld;
	::GetWindowRect(hWnd, rectOld);
	::ScreenToClient(hWndParent, rectOld.TopLeft());
	::ScreenToClient(hWndParent, rectOld.BottomRight());
	DWORD dwStyle = ::GetWindowLongPtr(hWnd,GWL_STYLE);
	if(((dwStyle & WS_VISIBLE) && (nFlags & SWP_SHOWWINDOW)) || (!(dwStyle & WS_VISIBLE) && (nFlags & SWP_HIDEWINDOW))){
		if(::EqualRect(rectOld, lpRect))
			return;     // nothing to do
	}
	// try to use DeferWindowPos for speed, otherwise use SetWindowPos
	if(lpLayout != NULL)
	{
		lpLayout->hDWP = ::DeferWindowPos(lpLayout->hDWP, hWnd, NULL,
			lpRect->left, lpRect->top,  lpRect->right - lpRect->left,
			lpRect->bottom - lpRect->top,nFlags);
	}
	else
	{
		::SetWindowPos(hWnd, NULL, lpRect->left, lpRect->top,
			lpRect->right - lpRect->left, lpRect->bottom - lpRect->top,nFlags);
	}
}
BOOL KFCWnd::UpdateBarsPosition(HDWP hDWP,RECT& rect, BOOL bResizeBars/* = TRUE*/)
{
	return TRUE;
}

void KFCWnd::RepositionBars(UINT nIDFirst, UINT nIDLast, UINT nIDLeftOver,
	BOOL bQuery, LPRECT lpRectParam, LPCRECT lpRectClient, BOOL bStretch,BOOL bResizeBars)
{
	//ASSERT(nFlags == 0 || (nFlags & ~reposNoPosLeftOver) == reposQuery || 
	//		(nFlags & ~reposNoPosLeftOver) == reposExtra);

	// walk kids in order, control bars get the resize notification
	//   which allow them to shrink the client area
	// remaining size goes to the 'nIDLeftOver' pane
	// NOTE: nIDFirst->nIDLast are usually 0->0xffff
	RECT rcc;
	KX_SIZEPARENTPARAMS layout;
	HWND hWndLeftOver = NULL;

	layout.bStretch = bStretch;
	layout.bResize = bResizeBars;
	layout.sizeTotal.cx = layout.sizeTotal.cy = 0;
	if (lpRectClient != NULL)
		layout.rect = *lpRectClient;    // starting rect comes from parameter
	else
		GetClientRect(&layout.rect);    // starting rect comes from client rect
	rcc = layout.rect;
	if (!bQuery)
		layout.hDWP = ::BeginDeferWindowPos(12); // reasonable guess
	else
		layout.hDWP = NULL; // not actually doing layout

	for (HWND hWndChild = ::GetTopWindow(m_hWnd); hWndChild != NULL;
		hWndChild = ::GetNextWindow(hWndChild, GW_HWNDNEXT))
	{
		UINT_PTR nIDC = ::GetDlgCtrlID(hWndChild);
		KFCWnd* pWnd = KFCWnd::FromHandle(hWndChild);
		if (nIDC == nIDLeftOver)
			hWndLeftOver = hWndChild;
		else if (nIDC >= nIDFirst && nIDC <= nIDLast && pWnd != NULL)
			::SendMessage(hWndChild, WM_SIZEPARENT, 0, (LPARAM)&layout);
	}
	// position bars and offset their dimensions	
	UpdateBarsPosition(layout.hDWP,layout.rect,bResizeBars);
	
	// if just getting the available rectangle, return it now...
	if (bQuery)
	{
		ASSERT(lpRectParam != NULL);
		if (bStretch)
			::CopyRect(lpRectParam, &layout.rect);
		else
		{
			lpRectParam->left = lpRectParam->top = 0;
			lpRectParam->right = layout.sizeTotal.cx;
			lpRectParam->bottom = layout.sizeTotal.cy;
		}
		return;
	}

	// the rest is the client size of the left-over pane
	if (nIDLeftOver != 0 && hWndLeftOver != NULL)
	{
		// allow extra space as specified by lpRectBorder
		ASSERT(lpRectParam != NULL);
		layout.rect.left += lpRectParam->left;
		layout.rect.top += lpRectParam->top;
		layout.rect.right -= lpRectParam->right;
		layout.rect.bottom -= lpRectParam->bottom;
		// reposition the window
		KFCWnd LeftOver(hWndLeftOver);
		LeftOver.CalcWindowRect(&layout.rect);
		//2012.04.20 KRKIM MDICLIENT  +2 ŭ  ǥõ ֱ SWP_DRAWFRAME ÷
		//׵θ谡 clientedge ´뵵 ׷  fix
		RepositionWindow(&layout, hWndLeftOver, &layout.rect,SWP_NOZORDER | SWP_NOACTIVATE|SWP_DRAWFRAME);
		//RECT rect = layout.rect;
		//::SetWindowPos(hWndLeftOver, NULL, rect.left, rect.top,
		//	rect.right - rect.left, rect.bottom - rect.top,
		//	SWP_NOZORDER | SWP_NOACTIVATE|SWP_DRAWFRAME);
	}

	// move and resize all the windows at once!
	if (layout.hDWP == NULL || !::EndDeferWindowPos(layout.hDWP)){
		//KFCTRACE("Warning: DeferWindowPos failed - low system resources.\n");
	}
}

void KFCWnd::SendMessageToDescendants(UINT message, WPARAM wParam, LPARAM lParam, BOOL bDeep, BOOL bOnlyPerm)
{ 
	ASSERT(::IsWindow(m_hWnd)); 
	KFCWnd::SendMessageToDescendants(m_hWnd, message, wParam, lParam, bDeep,bOnlyPerm);
}

void KFCWnd::SendMessageToDescendants(HWND hWnd, UINT message,
	WPARAM wParam, LPARAM lParam, BOOL bDeep, BOOL bOnlyPerm)
{
	// walk through HWNDs to avoid creating temporary CWnd objects
	// unless we need to call this function recursively
	for (HWND hWndChild = ::GetTopWindow(hWnd); hWndChild != NULL;
		hWndChild = ::GetNextWindow(hWndChild, GW_HWNDNEXT))
	{
		// if bOnlyPerm is TRUE, don't send to non-permanent windows
		if(bOnlyPerm)
		{
			KFCWnd* pWnd = KFCWnd::FromHandle(hWndChild);
			if(pWnd != NULL){
				// call window proc directly since it is a C++ window
				pWnd->WindowProc(pWnd->m_hWnd, message, wParam, lParam);
			}
		}
		else
		{
			// send message with Windows SendMessage API
			::SendMessage(hWndChild, message, wParam, lParam);
		}
		if (bDeep && ::GetTopWindow(hWndChild) != NULL)
		{
			// send to child windows after parent
			SendMessageToDescendants(hWndChild, message, wParam, lParam,
				bDeep, bOnlyPerm);
		}
	}
}

/* 
This called from KFCApp directly,If parent is modal dialog,this event wiil not be reached never 
*/
LRESULT KFCWnd::OnIdleUpdateCmdUI(WPARAM wParam, LPARAM lParam)
{
	if((GetStyle() & WS_VISIBLE))
	{
		KFCWnd *pParent = GetParentWnd();
		if(pParent == NULL || (pParent->GetStyle() & WS_VISIBLE)){
			kxFrame* pTarget = (kxFrame*)GetParentFrame();
			if(pTarget != NULL || KFCGetMainWnd() == this)
				OnUpdateCmdUI(pTarget,(BOOL)wParam);
		}
	}
	return 0L;
}

void KFCWnd::OnUpdateCmdUI(kxFrame* pTarget, BOOL bDisableIfNoHndler)
{

}

void KFCWnd::EnableShow(UINT nID,BOOL bEnable) /* enable  show  ÿ */
{
	::EnableWindow(GetDlgItem(nID),bEnable);
	::ShowWindow(GetDlgItem(nID),bEnable ? SW_SHOW:SW_HIDE);
}

BOOL KFCWnd::ModifyStyle(DWORD dwRemove, DWORD dwAdd, UINT nFlags)// throw()
{
	ASSERT(::IsWindow(m_hWnd));
	DWORD dwStyle = ::GetWindowLongPtr(m_hWnd, GWL_STYLE);
	DWORD dwNewStyle = (dwStyle & ~dwRemove) | dwAdd;
	if(dwStyle == dwNewStyle)
		return FALSE;
	::SetWindowLongPtr(m_hWnd, GWL_STYLE, dwNewStyle);
	if(nFlags != 0)
	{
		::SetWindowPos(m_hWnd, NULL, 0, 0, 0, 0,
			SWP_NOSIZE | SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE | nFlags);
	}
	return TRUE;
}

BOOL KFCWnd::ModifyStyleEx(DWORD dwRemove, DWORD dwAdd, UINT nFlags)// throw()
{
	ASSERT(::IsWindow(m_hWnd));
	DWORD dwStyle = ::GetWindowLongPtr(m_hWnd, GWL_EXSTYLE);
	DWORD dwNewStyle = (dwStyle & ~dwRemove) | dwAdd;
	if(dwStyle == dwNewStyle)
		return FALSE;
	::SetWindowLongPtr(m_hWnd, GWL_EXSTYLE, dwNewStyle);
	if(nFlags != 0)
	{
		::SetWindowPos(m_hWnd, NULL, 0, 0, 0, 0,
			SWP_NOSIZE | SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE | nFlags);
	}
	return TRUE;
}

int KFCWnd::GetDlgCtrlID()// const throw()
{
	ASSERT(::IsWindow(m_hWnd));
	return ::GetDlgCtrlID(m_hWnd);
}

int KFCWnd::SetDlgCtrlID(int nID)// throw()
{
	ASSERT(::IsWindow(m_hWnd));
	return (int)::SetWindowLongPtr(m_hWnd, GWL_ID, nID);
}

void KFCWnd::SetTabOrder(HWND hWndAfter/* = HWND_TOP*/)
{
	::SetWindowPos(GetSafeHwnd(),hWndAfter, 0, 0, 0, 0, SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE|SWP_FRAMECHANGED);
}

#if 0
Searching C:\PRG\MSVS\VC98\MFC\SRC\winctrl1.cpp

Found at line 229, file offset 6,344

        ASSERT(::IsWindow(m_hWnd));
        GetLBText(nIndex, rString.GetBufferSetLength(GetLBTextLen(nIndex)));
        rString.ReleaseBuffer();
}

/////////////////////////////////////////////////////////////////////////////
// CEdit

BOOL CEdit::Create(DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID)
{
        CWnd* pWnd = this;
        return pWnd->Create(_T("EDIT"), NULL, dwStyle, rect, pParentWnd, nID);
}

CEdit::~CEdit()
{
#endif

HICON KFCWnd::SetIcon(HICON hIcon, BOOL bBigIcon)
{
	HICON hPrevIcon;
	hPrevIcon = (HICON)::SendMessage(m_hWnd,WM_GETICON,(WPARAM)(bBigIcon == TRUE) ? ICON_BIG:ICON_SMALL,0L);
	::SendMessage(m_hWnd,WM_SETICON,(WPARAM)(bBigIcon == TRUE) ? ICON_BIG:ICON_SMALL,(LPARAM)(HICON)hIcon);
	return hPrevIcon;
}

HICON KFCWnd::GetIcon(BOOL bBigIcon) const
{
	HICON hIcon;
	hIcon = (HICON)::SendMessage(m_hWnd,WM_GETICON,(WPARAM)(bBigIcon == TRUE) ? ICON_BIG:ICON_SMALL,0L);
	return hIcon;
}



/* 2006.07.20 Add By KRKIM For interactive SDK window with class 
SubclassWindow use for HWND againist already created window.
*/
BOOL KFCWnd::Attach(HWND hWndNew,BOOL bForce)
{
	if(bForce == 0 && m_hWnd != NULL && ::IsWindow(m_hWnd))// only attach once, detach on destroy
		return FALSE;
	m_hParentWnd = ::GetParent(hWndNew);

#ifdef USE_MAPTABLE
	LPWNDMAPITEM lpMapItem;
	lpMapItem = theWndMap.Lookup(hWndNew);
	if(lpMapItem)
		return FALSE;// must not already be in permanent map

	theWndMap.Add(m_hWnd = hWndNew,(LPVOID)this);
#else
	KFCWnd::SetPointer(m_hWnd = hWndNew,this);
#endif

	return TRUE;
}

HWND KFCWnd::Detach()
{
	HWND hWnd = m_hWnd;
	if (hWnd != NULL)
	{
#ifdef USE_MAPTABLE
		LPWNDMAPITEM lpMapItem;
		lpMapItem = theWndMap.Lookup(hWnd);
		if(lpMapItem)
			theWndMap.Remove(hWnd); 
#else
		KFCWnd::SetPointer(hWnd,NULL);
#endif
		m_hWnd = NULL;
	}
	return hWnd;
}

KFCWnd * KFCWnd::FromHandle(HWND hWnd)
{
	KFCWnd *pWnd = NULL;
#ifdef USE_MAPTABLE
	LPWNDMAPITEM lpMapItem = theWndMap.Lookup(hWnd);
	pWnd = (lpMapItem) ? (KFCWnd *)lpMapItem->lpClass : NULL;
#else
	pWnd = KFCWnd::GetPointer(hWnd);
#endif
	return pWnd;
}

BOOL KFCWnd::PreCreateWindow(CREATESTRUCT &cs)
{
	//it's not need for predefined control-class names
	//BUTTON,COMBOBOX,EDIT,LISTBOX,MDICLIENT,RichEdit,RICHEDIT_CLASS,
	//SCROLLBAR,STATIC
	//if(cs.lpszClass == NULL)
	//{	//make sure the default window class is registered
	WNDCLASSEX wcex;
	wcex.cbSize = sizeof (WNDCLASSEX);
	wcex.style = CS_HREDRAW | CS_VREDRAW|CS_DBLCLKS;
	//m_wcex.lpfnWndProc = (WNDPROC) ::DefWindowProc;// default SDK window procedure: 
	wcex.lpfnWndProc = (WNDPROC) KFCWndBaseProc;//::XFCWndProc;// default SDK window procedure: 
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hInstance = KFCGetInstanceHandle();      // owner of the class: mandatory
	wcex.hIcon = LoadIcon(KFCGetResourceInstance(), (LPCTSTR)IDI_APPLICATION);
	wcex.hIconSm = NULL;
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_BTNFACE+1);//COLOR_WINDOW+1

	wcex.lpszMenuName = cs.lpszClass;
	wcex.lpszClassName = cs.lpszClass;   // mandatory
	
	return RegisterWndClass(wcex);
	//}
	//return TRUE;
}

BOOL KFCWnd::RegisterWndClass(WNDCLASSEX &wcex)
{
	WNDCLASS wndcls;
	if(::GetClassInfo(wcex.hInstance,wcex.lpszClassName,&wndcls))
		return FALSE;
	if(RegisterClassEx(&wcex) == 0){
		return FALSE;
	}
	return TRUE;
	//	throw KFCException ("RegisterClassEx");
}

void KFCWnd::PreSubClassWindow()
{
	// no default processing
}

BOOL KFCWnd::SubClassWindow(HWND hWnd,BOOL bForce)
{
	if (!Attach(hWnd,bForce))
		return FALSE;

	// allow any other subclassing to occur
	PreSubClassWindow();

	// now hook into the WndProc
	WNDPROC oldWndProc = (WNDPROC)(LONG_PTR)::SetWindowLongPtr(hWnd, GWLP_WNDPROC,(LONG_PTR)(WNDPROC)(this->WindowProc));
	if(oldWndProc == (WNDPROC)this->WindowProc) return FALSE;
	/*if(m_fnSuper == NULL)*/
	m_fnSuper = oldWndProc;
	m_bSubClassed = 1;
	return TRUE;
}

HWND KFCWnd::UnSubClassWindow()
{
	if(!::IsWindow(m_hWnd))
		return NULL;

	// set WNDPROC back to original value
	::SetWindowLongPtr(m_hWnd, GWLP_WNDPROC, (LONG_PTR)m_fnSuper);
	m_fnSuper = ::DefWindowProc;
	m_hWnd = NULL;
	m_dwState = 0;
	m_bSubClassed = 0;
	// and Detach the HWND from the CWnd object
	return Detach();
}

BOOL KFCWnd::IsWindowVisible()
{
	if(!IsWindow())
		return FALSE;
	return ::IsWindowVisible(m_hWnd);
}

BOOL KFCWnd::IsWindowHasVisible() //,IsWindowVisible  FALSE  WS_VISIBLE Ӽ ִ.
{
	DWORD dwStyle = ::GetWindowLongPtr(GetSafeHwnd(),GWL_STYLE);
	//BOOL f = IsWindowVisible();
	if(dwStyle & WS_VISIBLE)
		return TRUE;
	return FALSE;
}

/*
  caution! if the window has not WS_VISIBLE result of called ShowWindow(SW_HIDE),
  or SetWindowPos(SWP_HIDEWINDOW) 
  and then try to SetRedraw(TRUE),the Disabled window is shown as WS_VISIBLE.
  so,before calling SetRedraw,check the window is visible now.
  otherwise,SetRedraw(FALSE) cause NOT WS_VISIBLE.
 */
void KFCWnd::SetRedraw(BOOL bRedraw)
{ 
	if(m_hWnd && ::IsWindow(m_hWnd))
		::SendMessage(m_hWnd, WM_SETREDRAW, bRedraw, 0);
}

BOOL KFCWnd::RedrawWindow(LPCRECT lprcUpdate /*= NULL*/,HRGN hrgnUpdate/* = NULL*/,UINT flags/* = RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE*/)
{
	ASSERT(::IsWindow(m_hWnd));
	return ::RedrawWindow(m_hWnd, lprcUpdate,hrgnUpdate, flags);
}

HWND KFCWnd::GetDlgItem(int nID) const
{
	return ::GetDlgItem(m_hWnd,nID);
}

void KFCWnd::SetDlgItemText(int nID,LPCTSTR lpszString)
{
	::SetDlgItemText(m_hWnd,nID,lpszString);
}

int KFCWnd::GetDlgItemText(int nID,LPTSTR lpStr,int nMaxCount) const
{
	return ::GetDlgItemText(m_hWnd,nID,lpStr,nMaxCount);
}

UINT KFCWnd::GetDlgItemInt(int nID,BOOL *lpTranslated,BOOL bSigned)
{
	return ::GetDlgItemInt(m_hWnd,nID,lpTranslated,bSigned);
}

BOOL KFCWnd::SetDlgItemInt(int nID,UINT uValue,BOOL bSigned)
{
	return ::SetDlgItemInt(m_hWnd,nID,uValue,bSigned);
}

void KFCWnd::CheckDlgButton(int nIDButton,UINT nCheck)
{
	::CheckDlgButton(m_hWnd,nIDButton,nCheck);
}

void KFCWnd::CheckRadioButton(int nIDFirstButton,int nIDLastButton,int nIDCheckButton)
{
	::CheckRadioButton(m_hWnd,nIDFirstButton,nIDLastButton,nIDCheckButton);
}

UINT KFCWnd::IsDlgButtonChecked(int nIDButton) const
{
	return ::IsDlgButtonChecked(m_hWnd,nIDButton);
}

int KFCWnd::GetCheckedRadioButton(int nIDFirstButton,int nIDLastButton)
{
	for(int nID = nIDFirstButton; nID <= nIDLastButton; nID++)
		if(::IsDlgButtonChecked(m_hWnd,nID))
			return nID;
	return 0;
}

LRESULT KFCWnd::SendDlgItemMessage(int nID,UINT message,WPARAM wParam,LPARAM lParam)
{
	return ::SendDlgItemMessage(m_hWnd,nID,message,wParam,lParam);
}

LRESULT KFCWnd::SendMessage(UINT message,WPARAM wParam,LPARAM lParam)
{
	return ::SendMessage(m_hWnd,message,wParam,lParam);
}

LRESULT KFCWnd::PostMessage(UINT message,WPARAM wParam,LPARAM lParam)
{
	return ::PostMessage(m_hWnd,message,wParam,lParam);
}

void KFCWnd::GetFrameSpacing(LPRECT lprcFrameGap)
{
	RECT rcw,rcc;

	GetWindowRect(&rcw);
	ScreenToClient(&rcw);
	GetClientRect(&rcc);

	lprcFrameGap->left = rcc.left - rcw.left;
	lprcFrameGap->right= rcw.right - rcc.right;
	lprcFrameGap->top = rcc.top - rcw.top;
	lprcFrameGap->bottom = rcw.bottom - rcw.bottom;
}

HFONT KFCWnd::GetFont()
{
	return FORWARD_WM_GETFONT(m_hWnd,::SendMessage);
}

void KFCWnd::SetFont(HFONT hFont,BOOL bRedraw/* = TRUE*/)
{
	FORWARD_WM_SETFONT(m_hWnd,hFont,bRedraw,::SendMessage);
}

BOOL KFCWnd::SetWindowPos(HWND m_hWndAfter, int x, int y, int cx, int cy, UINT uFlags)
{ 
	ASSERT(::IsWindow(m_hWnd));
	return ::SetWindowPos(m_hWnd, m_hWndAfter,x, y, cx, cy, uFlags);
}

BOOL KFCWnd::SetWindowPos(HWND m_hWndAfter,RECT rc, UINT uFlags)
{
	ASSERT(::IsWindow(m_hWnd));
	return ::SetWindowPos(m_hWnd, m_hWndAfter,rc.left, rc.top, rc.right, rc.bottom, uFlags);
}

DWORD KFCWnd::DeferWindow(HDWP hWinPosInfo,HWND hWnd,HWND hWndInsertAfter,int x, int y, int cx,int cy, UINT uFlags)
{
	if (hWinPosInfo)
		return (DWORD)::DeferWindowPos(hWinPosInfo,hWnd,hWndInsertAfter,x,y,cx,cy,uFlags);
	else
		return (DWORD)SetWindowPos(hWndInsertAfter,x,y,cx,cy,uFlags);
}

DWORD KFCWnd::DeferWindow(HDWP hWinPosInfo,HWND hWnd,HWND hWndInsertAfter,RECT rc, UINT uFlags)
{
	return DeferWindow(hWinPosInfo,hWnd,hWndInsertAfter,rc.left,rc.top,rc.right,rc.bottom,uFlags);
}

UINT KFCWnd::SetSafeTimer(UINT nTimerID,const UINT nElapsed)
{
	ASSERT(GetSafeHwnd());
	UINT iTimer = 1;
	while (iTimer < 10000)
	{
		UINT res = SetTimer(nTimerID, nElapsed, NULL);
		if (res) return res;
		iTimer ++;
	}
	return 0;
}

#define USE_FADEIN

#ifdef USE_FADEIN
typedef BOOL(WINAPI *SLWA)(HWND, COLORREF, BYTE, DWORD);
//  . ɼ ٲ  ֽ.
#ifndef WS_EX_LAYERED
#define WS_EX_LAYERED           0x00080000
#define LWA_COLORKEY            0x00000001
#define LWA_ALPHA               0x00000002
#define ULW_COLORKEY            0x00000001
#define ULW_ALPHA               0x00000002
#define ULW_OPAQUE              0x00000004
#endif

void KFCWnd::SetTransparent(HWND hWnd,int rate,BOOL bKeepLayer)
{
	DWORD exstyle = GetWindowLongPtr(hWnd, GWL_EXSTYLE);

	//ϰ  ƾ.
	SLWA pSetLayeredWindowAttributes = NULL;  // Լ , ʱȭ.
	HINSTANCE hmodUSER32 = LoadLibrary("USER32.DLL"); // νϽ .
	pSetLayeredWindowAttributes=(SLWA)GetProcAddress(hmodUSER32,"SetLayeredWindowAttributes");
	SetWindowLongPtr(hWnd, GWL_EXSTYLE, exstyle | WS_EX_LAYERED);
	pSetLayeredWindowAttributes(hWnd, 0, (255 * rate) / 100, LWA_ALPHA);
	if(!bKeepLayer && rate >= 100){
		exstyle &= ~WS_EX_LAYERED;
		SetWindowLongPtr(hWnd, GWL_EXSTYLE, exstyle);
	}

	FreeLibrary(hmodUSER32);
}

DWORD KFCWnd::FadeThread(LPVOID pParam)
{
	KFCWnd *pRoot = reinterpret_cast<KFCWnd *> (pParam);
	pRoot->FadeProc();
	pRoot->m_FadeIO.hThreadFadeIn = NULL;
#ifdef _DEBUG
	OutputDebugString("FadeIn \n");
#endif
	return 0;
}

BOOL KFCWnd::IsFadeThreadRunning()
{
	return (m_FadeIO.hThreadFadeIn != NULL);
}

DWORD KFCWnd::FadeProc()
{
	int rate,srate;

	//ϰ  ƾ.
	SLWA pSetLayeredWindowAttributes = NULL;  // Լ , ʱȭ.
	HINSTANCE hmodUSER32 = LoadLibrary("USER32.DLL"); // νϽ .

	// fade out
	srate = (m_FadeIO.nStep < 0) ? 100 : 0;
	pSetLayeredWindowAttributes=(SLWA)GetProcAddress(hmodUSER32,"SetLayeredWindowAttributes");
	rate = srate;
	while(pSetLayeredWindowAttributes && !m_FadeIO.bAbort){

		if(srate == 0 && rate >= 100){
			rate = 100;
			srate = -1;
		}
		else if(srate == 100 && rate <= 0){
			rate = 0;
			srate = -1;
		}
		if(m_hWnd == NULL || !::IsWindow(m_hWnd))
			break;
		pSetLayeredWindowAttributes(m_hWnd,0, (255 * rate) / 100, LWA_ALPHA);
		if(srate == -1)
			break;
		rate += m_FadeIO.nStep;

		DWORD dwTick2 = GetTickCount();
		while(!m_FadeIO.bAbort && (GetTickCount() < dwTick2 + m_FadeIO.nDelay)){

		}
	}
	FreeLibrary(hmodUSER32);
	if(m_hWnd == NULL || !::IsWindow(m_hWnd))
		return 1;
	DWORD exstyle = GetWindowLongPtr(m_hWnd, GWL_EXSTYLE);
	if(!m_FadeIO.bKeepLayer && rate >= 100 && (exstyle & WS_EX_LAYERED)){
		exstyle &= ~WS_EX_LAYERED;
		SetWindowLongPtr(m_hWnd, GWL_EXSTYLE, exstyle);//100% equal NONE WS_EXLAYERED style
	}
	return 0;
}

//Fade In/Out Window
//nStep      :  > 0 for Fade In, < 0 for Fade Out
//nStepDelay :  delay(milisecond unit for timegap each Fade
//bKeepLayer :  keep WS_EX_LAYED style
//bUseThread :  TRUE = in thread mode
//              To fade in on WM_CREATE which the window is not shown yet,do use thread
//              by set bUseThread = TRUE.
//              Otherwise To fade out on WM_CLOSE or EndDialog(IDOK or IDCANCEL),
//              do not use thread by set bUseThread = FALSE because in thread mode,
//              not match sync with the window in main thread will be closed and not shown.
//              so to fade out(nStep < 10) when close window,you must blocking closing 
//              window using non-thread mode by set bUseThread = FALSE.

//If you Fade out on close time,you must set WS_EX_LAYERED first on WM_CREATE when 
//window not shown yet,because after shown window,call SetWindowLong(WS_EX_LAYERED -- )
//occur the window will be flicked.

//̹ 찡  ¿ SetWindowLong(WS_EX_LAYERED  SetLayeredWindowAttributes ȣϸ
//   ĥ. ,̸ WS_EX_LAYERED Ÿ  ΰ ȣؾ Ѵ.
//ʴ ¿ SetTransparent(pWnd->GetSafeHwnd(),0); layered rate = 0  ̸ϰ
// 츦 Showϰ UpdateWindowȣ   Լ ȣϸ  .
BOOL KFCWnd::FadeWindow(int nStep,int nStepDelay,BOOL bKeepLayer,BOOL bUseThread,DWORD dwThreadTimeout,BOOL bForceKillThread)//nStep < 0 means FadeOut
{
	DWORD dwRet;
	DWORD dwStyle = GetStyle();
	if(dwStyle & WS_CHILD)//only popup or overlapped window
		return FALSE;

	m_FadeIO.bAbort= FALSE;
	m_FadeIO.nStep  = nStep;
	m_FadeIO.nDelay = nStepDelay;
	m_FadeIO.bKeepLayer = bKeepLayer;
	
	DWORD exstyle = GetWindowLongPtr(m_hWnd, GWL_EXSTYLE);
	if(!(exstyle & WS_EX_LAYERED)){
		//̹ Window  SW_SHOW ¿ WS_EX_LAYERED Ÿ ϰ 
		//ٷ SetLayeredWindowAttributes rate > 0 ȣϸ, flicker  Ÿ.
		//ݴ rate = 0  ̱  flicker .
		//,FadeOut(nStep < 0)ÿ ̹ Create WS_EX_LAYERED Ÿ Ǿ ־ ̷   .
		//,FadeOut = nStep < 0  need to set WS_EX_LAYERED before call this function.
		SetWindowLongPtr(m_hWnd, GWL_EXSTYLE, exstyle | WS_EX_LAYERED);
		if(nStep < 0){
			//throw KFCException("Warning! Before call KFCWnd::FadeWindow,please set WS_EX_LAYED style at first before shown to prevent flicker window!\n");
		}
	}
	if(bUseThread){
		m_FadeIO.hThreadFadeIn = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE) FadeThread,(LPVOID)this,CREATE_SUSPENDED,&dwRet);
		//g_hThreadFadeIn = (HANDLE) _beginthreadex(NULL,0,threadProc_Fadein,(LPVOID)lParam,CREATE_SUSPENDED,&nDummy);
		if(!m_FadeIO.hThreadFadeIn)
			return FALSE;
		else{
			ResumeThread(m_FadeIO.hThreadFadeIn);
			DWORD dwStatus = WaitForSingleObject(m_FadeIO.hThreadFadeIn,dwThreadTimeout);
			if(dwStatus == WAIT_TIMEOUT && bForceKillThread){
				::TerminateThread(m_FadeIO.hThreadFadeIn, (DWORD)-1);
				CloseHandle(m_FadeIO.hThreadFadeIn);
				m_FadeIO.hThreadFadeIn = NULL;
			}
		}
	}
	else{
		FadeProc();
	}
	return TRUE;
}

BOOL KFCWnd::StopFadeThread(DWORD dwTimeout,BOOL bForce)
{
	if(m_FadeIO.hThreadFadeIn){
		DWORD dwStatus;
		m_FadeIO.bAbort = TRUE;
		::ResumeThread(m_FadeIO.hThreadFadeIn);
		// we'll wait for several seconds then continue execution
		dwStatus = WaitForSingleObject(m_FadeIO.hThreadFadeIn,dwTimeout);
		if(dwStatus == WAIT_TIMEOUT && bForce){
			::TerminateThread(m_FadeIO.hThreadFadeIn, (DWORD)-1);
			CloseHandle(m_FadeIO.hThreadFadeIn);
			m_FadeIO.hThreadFadeIn = NULL;
		}
	}
	return TRUE;
}

void KFCWnd::SetFadeInOnCreated(BOOL bFadeInCreated,int nStep,int nStepDelay)
{
	m_FadeIO.bCreated = bFadeInCreated;
	m_FadeIO.nStep  = nStep;
	m_FadeIO.nDelay = nStepDelay;
}
#endif